import serial
import time
import numpy as np
import matplotlib.pyplot as plt

def exinterface(): #it gives back shutdown message and plots the final graph
    print('> ' + 'Shutdown.')
    print(print(70*'-'))
    data = np.loadtxt(str(nomefile) + '.dat')
    plt.plot((1)*(data[:,0]), (1)*(data[:,1]), color='red')
    plt.title('IV Curve')
    plt.xlabel('Voltage (V)')
    plt.ylabel('Current (A)')
    plt.legend(('Idiode'),
           loc='upper center', shadow=True)
    plt.show()
    

def plot():   #it plots the graph while the shutdown continues
    data = np.loadtxt(str(nomefile) + '.dat')
    plt.plot((1)*(data[:,0]), (1)*(data[:,1]), color='red')
    plt.title('IV Curve')
    plt.xlabel('Voltage (V)')
    plt.ylabel('Current (A)')
    plt.legend(('Idiode'),
           loc='upper center', shadow=True) 
    plt.show(block=False)
    plt.pause(0.001)

def rampdown() :
    for z in range (int(volt),1,int(stepdown)):
        setvolt = 'SOUR:VOLT ' - str(z) #something is wrong here?
        gen.write(bytes(setvolt.encode('utf-8'))+b"\r\n")
        time.sleep(1)  
    voltOFF = 'SOUR:VOLT:STAT OFF'
    gen.write(bytes(voltOFF.encode('utf-8'))+b"\r\n")

    
#Start    
print(70*'-')
print('>' + 'To stop the program and initiate abort sequence, press CTRL+C.')
print(70*'-')

gen = serial.Serial()


# General configuration
diodeport = 'COM5'
volt     =    #It indicates the initial voltage 
stepvalue   =    #It indicates the step in the main voltage ramp 
stepdown = 1  #It indicates the step in the voltage shutdown ramp 
diodecurrlim =   #It indicates the soft current limit for the diode  

try:

#Keithley communication settings
    gen.port = diodeport
    gen.stopbits = 1
    gen.timeout = 1
    gen.bytesize = 8
    gen.xonxoff = True
    gen.open()
    

except: #any exception

    print('> ' + "Problems with starting communication with the first Keithley.")
    if gen.isOpen():
        gen.close()
    exinterface()
gen.flush()


try:

    while gen.dtr != True:
        gen.readline()

# define 
# start-up procedure (check instrument id, reset, other operations needed)
# based on the typical command structure del tipo voltrange = 'SOUR:VOLT:RANG 10'
# to be sent with the structure  gen.write(bytes(voltrange.encode('utf-8'))+b"\r\n")
# A response message can be read out through the structure:
# lettura = gen.readline()
# if (lettura != b''): #or (lettura2 != b''): #whenever you have an interesting response from the instrument, even if not expected
#               lettura = lettura.decode('utf-8').replace('\r\n','')

#Examples: write
    reset = '*RST' #manda reset
    gen.write(bytes(reset.encode('utf-8'))+b"\r\n")

#Examples: write and read
    identita = '*IDN?' #richiedi identita'   
    lettura = gen.readline()
    if (lettura != b''): #whenever you have an interesting response from the instrument, even if not expected
         lettura = lettura.decode('utf-8').replace('\r\n','')
         print('>  ' + lettura)

#Keithley operation parameters and actions
    zchOFF = ' ' #rimuovi zerocheck
    voltON = ' ' #abilita output voltage source
    voltrange = ''   #Select 10/50/500V source range
    currlimit = '' #Set current limit to ...
    #currrange = ''            #Select the 200nA range
    currrange = ''             #Enable auto current range
 
#Interactive input:  
    print('> ' + "Indicate the positive voltage you want to reach")
    maxvolt = input('< ')
    while float(maxvolt) < 0:
        print('***Voltage must be postive!***')
        print('> Indicate the negative voltage you want to reach (indicate the sign)')
        maxvolt = input('< ')
    print('> ' + "Indicate file name (.dat) where data must be saved")
    nomefile = input('<  ')

#Define file name and type
    file = open(str(nomefile) + '.dat','w')
   

#Ramp up voltage and read current at each step
    reading   = 'FORM:ELEM VSO, READ'     #Select reading, voltage source data
    print('> ' + "Ramp launch")
    for volt in range (0,int(float(maxvolt)/stepvalue)+1,1):
        #print(maxvolt, stepvalue, int(maxvolt)/stepvalue)
        setvolt = 'SOUR:VOLT ' + str(volt*stepvalue) 
        gen.write(bytes(setvolt.encode('utf-8'))+b"\r\n")
        time.sleep(0.5) #stabilize for 0.5 sec before reading values
        
        letturadati = 'READ?'
        gen.write(bytes(letturadati.encode('utf-8'))+b"\r\n") 
        time.sleep(0.2) #essential otherwise it skips a step and as a consequence provides data related to the previous voltage 
        lettura = gen.readline()
       
        if (lettura != b''): #whenever you have an interesting response from the instrument, even if not expected
                lettura = lettura.decode('utf-8').replace('\r\n','')
                for k in range (0, len(lettura)):
                    if lettura[k]== ',':
                      letturacurr = lettura[0:k]
                      letturavolt = lettura[k+1:] 
                      break
                print('>  ' + 'voltage (V) = ' + str(volt*stepvalue) + ' Idiode (A) = ' + letturacurr + ' Eq. Resistance (Ohm) = ' + str(float(letturavolt)/float(letturacurr)) )
                file.write(str(volt*stepvalue) + ' ' + letturacurr + '\n')

# Impose current soft limit
                if (abs(float(letturacurr))>= float(diodecurrlim)):
                    print('\n' + '*****WARNING*****' + '\n')
                    print(letturacurr + ' A \n')
                    print('*****TOO HIGH CURRENT*****' + '\n')
                    break 
        
    file.close()
    plot()
    print('> ' + "Starting shutdown procedure")

#Ramp down and close communication
    rampdown()
    gen.close()    
    exinterface()
 
#Define what to do at the exeption 
except: 

    print('\n' + '*****FORCED SHUTDOWN*****')
    file.close()
    plot()
    rampdown()
    gen.close()
    
    exinterface()